#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

nplc = 50
rngx = 10
soakt = 5
cycles = 1

log_name     = ("dcl_%dvdc_4808_3458xdvs_abcd_d1281_nplc%d_soak%d_nov2021.csv" % (rngx, nplc, soakt))
log_name_raw = ("dcl_%dvdc_4808_3458xdvs_abcd_d1281_nplc%d_soak%d_raw_nov2021.csv" % (rngx, nplc, soakt))

#fluke = Gpib.Gpib(0, 4, timeout=30) # Fluke 5720A, GPIB Address = 5
fluke = vxi11.Instrument("192.168.1.12", "gpib0,2") # Keysight 3458A, GPIB Address = 22
fluke.clear()
#fluke.write("*IDN?")
#print "Source detected = %s" % fluke.read()

#dmm = Gpib.Gpib(0,  14, timeout=30)# Keysight 3458A, GPIB Address = 22
#dmm2 = Gpib.Gpib(0, 15, timeout=30)# Keysight 3458A, GPIB Address = 22
#dmm3 = Gpib.Gpib(0, 23, timeout=30)# Keysight 3458A, GPIB Address = 22
dmm = vxi11.Instrument("192.168.1.10", "gpib0,3") # Keysight 3458A, GPIB Address = 22
dmm2 = vxi11.Instrument("192.168.1.10", "gpib0,2") # Keysight 3458A, GPIB Address = 22
dmm3 = vxi11.Instrument("192.168.1.10", "gpib0,11") # Keysight 3458A, GPIB Address = 22
dmm5 = vxi11.Instrument("192.168.1.10", "gpib0,23") # Keysight 3458, GPIB Address = 1
dmmd = vxi11.Instrument("192.168.1.10", "gpib0,8") # Datron 1281, GPIB Address = 1

#dmm5.timeout = 20
#dmm5.clear()
#dmm5.write("*IDN?")
#print "DUTF detected = %s" % dmm5.read()

#dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

fluke.write("F0=") #DCV function
fluke.write("P0=") #24 hr spec
fluke.write("G0=") #Local guard
fluke.write("R6=") #10V range
fluke.write("S0=") #Local sense
fluke.write("O1=") #Output enable
fluke.write("M%.7e=" % 0.000000) #Output enable

#fluke.write("STBY")
#fluke.write("RANGELCK OFF")
#fluke.write("OUT %.2f V, 0 Hz" % rngx)
#fluke.write("RANGELCK ON")
#fluke.write("STBY")
#fluke.write("OUT 0.0 V, 0 Hz")
#fluke.write("EXTGUARD OFF")
#fluke.write("OPER")
time.sleep(soakt)
print "SRC configured"
dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV %.2f" % rngx)
dmm.write("NPLC %.2f" % nplc)
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured 14"
dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV %.2f" % rngx)
dmm2.write("NPLC %.2f" % nplc)
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT configured 15"
dmm3.write("BEEP")
dmm3.write("END ALWAYS")
dmm3.write("DCV %.2f" % rngx)
dmm3.write("NPLC %.2f" % nplc)
dmm3.write("NDIG 8")
dmm3.write("TRIG AUTO")
dmm3.write("MATH OFF")
print "DUT configured 23"
dmm5.write("BEEP")
dmm5.write("END ALWAYS")
dmm5.write("DCV %.2f" % rngx)
dmm5.write("NPLC %.2f" % nplc)
dmm5.write("NDIG 8")
dmm5.write("TRIG AUTO")
dmm5.write("MATH OFF")
print "DUT configured N"

dmmd.write("*RST")
dmmd.write("*CLR")
dmmd.write("INPUT FRONT")
dmmd.write("TRG_SRCE EXT")
dmmd.write("GUARD EXT")
dmmd.write("DCV 10,RESL8,FAST_OFF")
dmmd.write("AVG OFF")
dmmd.timeout = 60

#dmm5.write("*RST")
#dmm5.write(":INP:PRE:STAT OFF")
#dmm5.write(":INIT:CONT OFF")
#dmm5.write(":SYST:PRES")
#dmm5.write(":FORM:ELEM READ")
#dmm5.write(":SYST:AZER:STAT ON")
#dmm5.write(":ABOR")
#dmm5.write(":SENS:FUNC 'VOLT:DC'")
#dmm5.write(":SENS:VOLT:DC:RANG %.2f" % rngx)
#dmm5.write(":SENS:VOLT:DC:NPLC %.2f" % nplc)
#dmm5.write(":SENS:VOLT:DC:AVER:STAT OFF")
#dmm5.write(":SENS:VOLT:DC:DIG 9")


#dmm.write("ACAL DCV")
#dmm2.write("ACAL DCV")
#dmm3.write("ACAL DCV")
#time.sleep(160)
'''
for vcnt in range (0,2):
    dmm3.write("*TRG;GET;RDG?")
    dmm3.read()
    dmm4.write("READ?") # Get reading
    dmm4.read()
'''
dmm.write("TARM SGL")
dmm.read()
dmm.write("MATH NULL")
dmm.write("TARM SGL") # Get reading
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
dmm2.write("MATH NULL")
dmm2.write("TARM SGL") # Get reading
dmm2.read()
dmm3.write("TARM SGL")
dmm3.read()
dmm3.write("MATH NULL")
dmm3.write("TARM SGL") # Get reading
dmm3.read()
dmm5.write("TARM SGL")
dmm5.read()
dmm5.write("MATH NULL")
dmm5.write("TARM SGL") # Get reading
dmm5.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;hp3458a;hp3458b;hp3458c;hp3458d;d1281;sdev;sdev2;sdev3;sdev4;sdev5;temp;temp2\r\n")
dile.close()

with open(log_name_raw, 'a') as diler:
    diler.write ("date;source;hp3458a;hp3458b;hp3458c;hp3458d;d1281;sdev;sdev2;sdev3;sdev4;sdev5;temp;temp2\r\n")
diler.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name
dmm.write("TEMP?")
temp = float(dmm.read())
dmm2.write("TEMP?")
temp2 = float(dmm2.read())

for cix in range(0, cycles, 1):

    for i in range(-110,110,1):
	median = 0.0
        rrsdev = 0.0
	array = []
        median2 = 0.0
	sdev2 = 0.0
        array2 = []
	median3 = 0.0
        sdev3 = 0.0
	array3 = []
        median4 = 0.0
	sdev4 = 0.0
        array4 = []
        median5 = 0.0
	sdev5 = 0.0
        array5 = []
	set_value = (float(i) / 10)
	fluke.write("M%.6e=" % set_value) 
	print("M%.6f=" % set_value) 
	#Output enable        fluke.write("OUT %.7f;OPER" % set_value)
	fluke.write("O1=")
        time.sleep(soakt)
	for ix in range (0,8): #take more samples
	    dmmd.write("X?")
	    dmm.write("TARM SGL")
    	    dmm2.write("TARM SGL")
	    dmm3.write("TARM SGL")
	    dmm5.write("TARM SGL")
    	    val = float(dmm.read())
	    val2 = float(dmm2.read())
	    val3 = float(dmm3.read())
	    val4 = float(dmm5.read())
	    val5 = float(dmmd.read())
	    array.extend([val])
	    array2.extend([val2])
	    array3.extend([val3])
	    array4.extend([val4])
	    array5.extend([val5])
	    if abs(set_value) >= 0.05:
		print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f DD %.8f, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6),val5,((val5 / set_value - 1) * 1e6) ))
    	    if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
		print ("Smoke escaped, check connections")
		fluke.write("OUT 0 V")
		fluke.write("STBY")
		quit()
	    with open(log_name_raw, 'a') as dileraw:
		rsdev = np.std(array)
		rsdev2 = np.std(array2)
		rsdev3 = np.std(array3)
		rsdev4 = np.std(array4)
		rsdev5 = np.std(array5)
		dileraw.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.6f;%.1f;%.1f\r\n" % (set_value, val, val2, val3, val4, val5, rsdev, rsdev2, rsdev3, rsdev4, rsdev5, temp, temp2)))
    	    dileraw.close()

	median = np.median(array[3:])
	sdev = np.std(array[1:])
	sdev2 = np.std(array2[1:])
	sdev3 = np.std(array3[1:])
	sdev4 = np.std(array4[1:])
	sdev5 = np.std(array5[1:])
	median2 = np.median(array2[3:])
	median3 = np.median(array3[3:])
	median4 = np.median(array4[3:])
	median5 = np.median(array5[3:])
	if abs(float(i) / 10) >= 0.0005:
	    dev1 = ((median / set_value - 1) * 1e6)
	    dev2 = ((median2 /set_value - 1) * 1e6)
	    dev3 = ((median3 /set_value - 1) * 1e6)
	    dev4 = ((median4 /set_value - 1) * 1e6)
	    dev5 = ((median5 /set_value - 1) * 1e6)
	    print("\033[32;1mSRC %.4f \033[33;1mA %.9f, sdev = %.3f uV, med  %.8f\033[35;1mB %.9f, sdev = %.3f uV, med = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f DD %.9f, sdevd = %.3f uV, medd = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4,val5,sdev5*1e6, median5 ))
	with open(log_name, 'a') as dile:
    	    dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, median5, sdev, sdev2, sdev3, sdev4, sdev5, temp, temp2)))
	dile.close()

	dmm.write("TEMP?")
	temp = float(dmm.read())
	dmm2.write("TEMP?")
	temp2 = float(dmm2.read())

#fluke.write("OUT 0 V")
#fluke.write("STBY")
#fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
dmm3.write("RESET")
fluke.write("O0=") #Output enable
fluke.write("GTL") #Output enable